

coeffs=coef_out;
coeffs_I=reshape(coeffs(1:end/2),[n_k,n_p]);
coeffs_V=reshape(coeffs(end/2+1:end),[n_k,n_p]);

dep_=.02;
gamma_=.33;
beta_=.99;
rho_=1/2;
alpha_=6;
s_eps_=.0088;
phi_p=.92;
p_bar=.02/4;
DIS=.4;

sd_p=.0085/4;
inv_p=sd_p*sqrt(1-phi_p^2);

k_max=log(36);
k_min=log(30);

p_max=.04/4;
p_min=0;



%%%%%%%%%%
%%% now we need to get the residual given the consumption and value
%%% functions.  The reisudal is calculated at the chebyshev roots.

points_k=linspace(k_min,k_max,50);
points_p=linspace(0,.05/4,50);


eps=[-5.38748089
-4.60368245
-3.94476404
-3.347854567
-2.788806058
-2.254974002
-1.738537712
-1.234076215
-0.737473729
-0.245340708
0.245340708
0.737473729
1.234076215
1.738537712
2.254974002
2.788806058
3.347854567
3.94476404
4.60368245
5.38748089
];


eps=sqrt(2)*eps;
    
ww=(pi^(-1/2))*[2.2293936455400E-13
4.3993409922600E-10
1.0860693707700E-07
7.8025564785000E-06
2.2833863601700E-04
3.2437733422400E-03
2.4810520887500E-02
1.0901720602000E-01
2.8667550536300E-01
4.6224366960100E-01
4.6224366960100E-01
2.8667550536300E-01
1.0901720602000E-01
2.4810520887500E-02
3.2437733422400E-03
2.2833863601700E-04
7.8025564785000E-06
1.0860693707700E-07
4.3993409922600E-10
2.2293936455400E-13
];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

points_k = (points_k-k_min)*2/(k_max-k_min) -1;
points_a = (points_p-p_min)*2/(p_max-p_min) -1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[k_grid p_grid]=ndgrid(points_k,points_a);
[k_grid2 p_grid2]=ndgrid(points_k,points_a);


I=0*p_grid;
V=I;

for i_k=0:n_k-1
    for i_p=0:n_p-1
            poly_=polyval(Chebyshevpoly(i_k),k_grid)...
                .*polyval(Chebyshevpoly(i_p),p_grid);
           
            I=I+poly_*coeffs_I(i_k+1,i_p+1);
            V=V+poly_*coeffs_V(i_k+1,i_p+1);
           
    end
end

I=max(I,0);

eps=permute(eps,[2,3,1]);
ww=permute(ww,[2,3,1]);


k_grid2=(k_grid+1)*(k_max-k_min)/2+k_min;
p_grid2= (p_grid+1)*(p_max-p_min)/2+p_min;

%% turn k into current period scaling
k = k_grid2;
p = p_grid2;

C=exp(gamma_*k) - I.*exp(k);
%% k_prime at this point is defined in terms of period t's scaling (not t+1, i.e. _prime)
k_prime=log(exp(k)*(1-dep_) + I.*exp(k) );
p_prime = bsxfun(@plus,(1-phi_p)*p_bar + phi_p*p,inv_p*eps);

%% now we rescale k_prime in case of a disaster shock
k_prime=repmat(k_prime,[1,1,1,2]);
p_prime=repmat(p_prime,[1,1,1,2]);
%% 1 is no disaster, 2 is disaster

%% we assume that an equal amount of capital is destroyed in the
%% disaster, so there's no need to rescale capital

% k_prime(:,:,:,1)=k_prime(:,:,:,1)+DIS*p./(1-p);
% k_prime(:,:,:,2)=k_prime(:,:,:,2)-DIS;
    
k_prime2=(k_prime-k_min)*2/(k_max-k_min) -1;
p_prime2=(p_prime-p_min)*2/(p_max-p_min) -1;


    I_prime=0*p_prime;
    V_prime=I_prime;
    for i_k=0:n_k-1
        for i_p=0:n_p-1
                poly2=bsxfun(@times,...
                            polyval(ChebyshevPoly(i_k),k_prime2)...
                            ,polyval(ChebyshevPoly(i_p),p_prime2));

                I_prime=bsxfun(@plus,I_prime,poly2*coeffs_I(i_k+1,i_p+1));
                V_prime=bsxfun(@plus,V_prime,poly2*coeffs_V(i_k+1,i_p+1));
        end
    end
    I_prime=max(I_prime,0);
    V_prime=exp(V_prime);
    
    C_prime=bsxfun(@plus,exp(gamma_*k_prime), - bsxfun(@times,I_prime,exp(k_prime)));
%%%% get EV

%     C_prime(:,:,:,1)=bsxfun(@times,C_prime(:,:,:,1),exp(DIS.*p./(1-p)));
%     C_prime(:,:,:,2)=bsxfun(@times,C_prime(:,:,:,2),exp(-DIS));
    
    V_prime2=V_prime;
    V_prime2(:,:,:,1)=bsxfun(@times,V_prime2(:,:,:,1),exp(DIS.*p./(1-p)));
    V_prime2(:,:,:,2)=bsxfun(@times,V_prime2(:,:,:,2),exp(-DIS));
    
    EV=V_prime2.^(1-alpha_);
    EV2=bsxfun(@times,EV(:,:,:,1),(1-p)) + bsxfun(@times,EV(:,:,:,2),p);
    EV=sum(bsxfun(@times,EV2,ww),3).^(1./(1-alpha_));
    
    RV=bsxfun(@times,V_prime,1./EV).^(rho_-alpha_);
    CC=bsxfun(@times,max(C_prime,.0001),1./C).^(-rho_);

    SDF=beta_*CC.*RV;
    SDF(:,:,:,1)=bsxfun(@times,SDF(:,:,:,1),exp(-alpha_*DIS.*p./(1-p)));
    SDF(:,:,:,2)=bsxfun(@times,SDF(:,:,:,2),exp(alpha_*DIS));
    
    SDF2=bsxfun(@times,SDF(:,:,:,1),(1-p)) + bsxfun(@times,SDF(:,:,:,2),p);
    Rf=1./sum(bsxfun(@times,SDF2,ww),3);
    
    Rw=(V_prime.^(1-rho_)).*(C_prime.^rho_)/(1-beta_);
    Rw=bsxfun(@times,Rw,1./((exp(V).^(1-rho_)).*(C.^rho_)/(1-beta_) - C));
    Rw(:,:,:,1)=bsxfun(@times,Rw(:,:,:,1),exp(DIS.*p./(1-p)));
    Rw(:,:,:,2)=bsxfun(@times,Rw(:,:,:,2),exp(-DIS));
    
    ERw=bsxfun(@times,Rw(:,:,:,1),(1-p)) + bsxfun(@times,Rw(:,:,:,2),p);
    ERw=sum(bsxfun(@times,ERw,ww),3);
    ERw=ERw-Rf;
    
    Rk = gamma_*exp((gamma_-1)*k_prime);
    Rk(:,:,:,1)=bsxfun(@plus,Rk(:,:,:,1),(1-dep_)*exp(DIS.*p./(1-p)));
    Rk(:,:,:,2)=bsxfun(@plus,Rk(:,:,:,2),(1-dep_)*exp(-DIS));
    
    err=bsxfun(@times,Rk,SDF);
    err2=bsxfun(@times,err(:,:,:,1),(1-p)) + bsxfun(@times,err(:,:,:,2),p);
    Euler=sum(bsxfun(@times,err2,ww),3);
    
    V2 = (1-beta_)*C.^(1-rho_) + beta_*EV.^(1-rho_);

    Error=[Euler(:)-1;
            V(:)-log(V2(:))/(1-rho_)];
 